#ifndef __gpmain_h__
#define __gpmain_h__

#include "gpdef.h"
#include "gpstdlib.h"
#include "gpstdio.h"
#include "gpgraphic.h"
#include "gpmm.h"
#include "gpfont.h"

GPDRAWSURFACE gpDraw[2];
int nflip;

extern const unsigned int	bg[320][60];	//size : 320 * 240
extern const unsigned char tetrisbg[16172];
extern const unsigned short bgsound[1240312];
extern int  Block[7][4][4][4];
extern const unsigned int tet_bg[320][60];

#define	LCD_WIDTH	320	//width of LCD
#define	LCD_HEIGHT	240	//height of LCD
#define	BG_WIDTH	320	//width of background image
#define	BG_HEIGHT	240	//height of background image

#define YES   1
#define NO    0
#define SUCCESS 1
#define FAIL    0
#define ON   1    // Timer state
#define OFF  0    //
#define ALIVE 1   // PlayerState
#define WAIT 2   // PlayerState
#define DEAD  0   // 
#define TRUE 1
#define FALSE 0

	int Screen[21][12];
	int OldScreen[21][12];      //   ũ ̺
	int NowX, NowY, RotateNum, crashCount;
	int BlockNum;
	int NextBlockNum;
	int PlayerState;
	int FullLineNum;
	int HiScore;
	int GameOver;
	int Stage=0;
	int Pause=ON;
	ulong m_size;
	int	Start();
	void init();
	void End();
	int  Update();
	void ChangeScreen();
	void PutFps();
	void Wait(long Delay);
	void resume();
	void InitScreenTable();
	void CheckFullLine();
	void UpdateScreenTable();
	int DownMove();
	void Rotate();
	void Rotate2();
	void RightMove();
	void LeftMove();
	int BlockCanMove(int x,int y);
	void DrawNextBlock();
	void DrawBlock();
	void InitMedia();
	void StartGame();
	void InitBlockState();
	void GpRect( int left, int top, unsigned char color_line, unsigned char color );
	

#define	MIN(x, y)	((x) < (y) ? (x) : (y))		
#define	MAX(x, y)	((x) > (y) ? (x) : (y))		


#endif /*__gpmain_h__*/
